#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file RTC_View_Gui.py
 @brief 表示GUI
 @date $Date$


"""
import sys
import time
import cv2
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

import rtc_gui
# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

pose=[]
pose=10*[0]
load=[]
load=10*[0]
mode=[]
mode=10*[0]
smode=[]
smode=10*[0]
vel=[]
vel=10*[0]
sub_ANG=[]
sub_ANG=10*[0]
# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
rtc_view_gui_spec = ["implementation_id", "RTC_View_Gui", 
		 "type_name",         "RTC_View_Gui", 
		 "description",       "表示GUI", 
		 "version",           "1.0.0", 
		 "vendor",            "AIZUK", 
		 "category",          "Viewer", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class RTC_View_Gui
# @brief 表示GUI
# 
# 
class RTC_View_Gui(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_Pose3D = RTC.TimedPose3D(RTC.Time(0,0),0)
		"""
		"""
		self._Pose3DIn = OpenRTM_aist.InPort("Pose3D", self._d_Pose3D)
		self._d_Sub_Deg = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		"""
		"""
		self._Sub_DegIn = OpenRTM_aist.InPort("Sub_Deg", self._d_Sub_Deg)
		self._d_Load = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		"""
		"""
		self._LoadIn = OpenRTM_aist.InPort("Load", self._d_Load)
		self._d_Mode = RTC.TimedLongSeq(RTC.Time(0,0),[])
		"""
		"""
		self._ModeIn = OpenRTM_aist.InPort("Mode", self._d_Mode)
		self._d_Velocity2D = RTC.TimedVelocity2D(RTC.Time(0,0),0)
		"""
		"""
		self._Velocity2DIn = OpenRTM_aist.InPort("Velocity2D", self._d_Velocity2D)
		self._d_Scan_Mode = RTC.TimedLongSeq(RTC.Time(0,0),[])
		"""
		"""
		self._Scan_ModeIn = OpenRTM_aist.InPort("Scan_Mode", self._d_Scan_Mode)


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		
		# Set InPort buffers
		self.addInPort("Pose3D",self._Pose3DIn)
		self.addInPort("Sub_Deg",self._Sub_DegIn)
		self.addInPort("Load",self._LoadIn)
		self.addInPort("Mode",self._ModeIn)
		self.addInPort("Velocity2D",self._Velocity2DIn)
		self.addInPort("Scan_Mode",self._Scan_ModeIn)
		
		# Set OutPort buffers
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
	
		
		return RTC.RTC_OK
	
		##
		# 
		# The finalize action (on ALIVE->END transition)
		# formaer rtc_exiting_entry()
		# 
		# @return RTC::ReturnCode_t
	
		# 
	def onFinalize(self):
	
		return RTC.RTC_OK
	
		##
		#
		# The startup action when ExecutionContext startup
		# former rtc_starting_entry()
		# 
		# @param 
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onStartup(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The shutdown action when ExecutionContext stop
		# former rtc_stopping_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onShutdown(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The activated action (Active state entry action)
		# former rtc_active_entry()
		#
		# @param ec_id target ExecutionContext Id
		# 
		# @return RTC::ReturnCode_t
		#
		#
	def onActivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The dea
		# former rtc_active_exit()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onDeactivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The execution action that is invoked periodically
		# former rtc_active_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onExecute(self, ec_id):
		#self,set_pos()
		if self._Pose3DIn.isNew():
			Pose = self._Pose3DIn.read()
			pose[0]=Pose.data.position.x
			pose[1]=Pose.data.position.y
			pose[2]=Pose.data.position.z
			
			pose[3]=Pose.data.orientation.r
			pose[4]=Pose.data.orientation.p
			pose[5]=Pose.data.orientation.y
		
		if self._Sub_DegIn.isNew():
			SDA = self._Sub_DegIn.read()
			
			sub_ANG[0]=SDA.data[0]
			sub_ANG[1]=SDA.data[1]
			sub_ANG[2]=SDA.data[2]
			sub_ANG[3]=SDA.data[3]
			sub_ANG[4]=SDA.data[4]
			sub_ANG[5]=SDA.data[5]
			
		if self._LoadIn.isNew():
			LOD = self._LoadIn.read()
			load[0]=LOD.data[0]
			load[1]=LOD.data[1]
			load[2]=LOD.data[2]
			load[3]=LOD.data[3]
			load[4]=LOD.data[4]
			load[5]=LOD.data[5]
			
		if self._ModeIn.isNew():
			MOD = self._ModeIn.read()
			mode[0]=MOD.data[0]
			mode[1]=MOD.data[1]
			mode[2]=MOD.data[2]
			mode[3]=MOD.data[3]
			mode[4]=MOD.data[4]
			mode[5]=MOD.data[5]
		if self._Scan_ModeIn.isNew():
			SMOD = self._Scan_ModeIn.read()
			smode[0]=SMOD.data[0]
			smode[1]=SMOD.data[1]
			smode[2]=SMOD.data[2]
			smode[3]=SMOD.data[3]
			smode[4]=SMOD.data[4]
			smode[5]=SMOD.data[5]
			
		if self._Velocity2DIn.isNew():
			MOD = self._Velocity2DIn.read()
			vel[0]=MOD.data.vx
			vel[1]=MOD.data.vy
			vel[2]=MOD.data.va
			#print self.x
		#	print "python"
		#	print self.roll
		#	self.roll   = self._d_Pose3D.data.orientation.r
		#	self.pitch   = self._d_Pose3D.data.orientation.p
		#	self.yaw   = self._d_Pose3D.data.orientation.y
		#self.print_data()
		#print self.roll
		#;
		#print "python"
		return RTC.RTC_OK
	
		##
		#
		# The aborting action when main logic error occurred.
		# former rtc_aborting_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onAborting(self, ec_id):
		return RTC.RTC_OK
	
		##
		#
		# The error action in ERROR state
		# former rtc_error_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onError(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The reset action that is invoked resetting
		# This is same but different the former rtc_init_entry()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onReset(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The state update action that is invoked after onExecute() action
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#

		#
	def onStateUpdate(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The action that is invoked when execution context's rate is changed
		# no corresponding operation exists in OpenRTm-aist-0.2.0
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onRateChanged(self, ec_id):
	
		return RTC.RTC_OK
	
	def set_pose(self,pose_in,subang_in,load_in,mode_in,smode_in,vel2d_in):
		for i in range(6):
			pose_in[i]=pose[i]
			subang_in[i]=sub_ANG[i]
			load_in[i]=load[i]
	#	load_in[5]=load[5]
		for i in range(10):
			mode_in[i]=mode[i]
			smode_in[i]=smode[i]
		for i in range(4):
			vel2d_in[i]=vel[i]
		
		#	pose_in[0]=pose[0]
		#	pose_in[1]=pose[1]
		#	pose_in[2]=pose[2]
		#	pose_in[3]=pose[3]
		#	pose_in[4]=pose[4]
		#	pose_in[5]=pose[5]
			
			
			
	def get_data(self):
        	return self.x, self.y, self.z, self.roll, self.pitch, self.yaw
	def print_data(self):
		print self.get_data()
        	#return self.x, self.y, self.z, self.roll, self.pitch, self.yaw


def RTC_View_GuiInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=rtc_view_gui_spec)
    manager.registerFactory(profile,
                            RTC_View_Gui,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    RTC_View_GuiInit(manager)

    # Create a component
    comp = manager.createComponent("RTC_View_Gui")

def main():
#GUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUI#

	TestCanvas = rtc_gui.RTC_GUI()
	TestCanvas.master.title("UI")#window名
	
#GUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUIGUI#
	
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	#mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	RTC_View_GuiInit(mgr)
    	comp = mgr.createComponent("RTC_View_Gui")
 	TestCanvas.set_on_update(comp.set_pose)
	#MyModuleInit(mgr)
	
	#
	mgr.runManager(True)
	TestCanvas.mainloop()

if __name__ == "__main__":
	main()

